/* Copyright (c) 1992 AT&T Bell Laboratories. */
/* C++. Styl i technika zaawansowanego programowania */
/* James O. Coplien */
/* Wszystkie prawa zastrzeone. */

class Telephone {
public:
    void ring();
    Bool isOnHook() isTalking(), isDialing();
    DigitString collectDigits();
    LineNumber extension();
    ~Telephone();
protected:
    Telephone();
    LineNumber extensionData;
};

class POTSPhone : public Telephone {
public:
    Bool runDiagnostics();
    POTSPhone();
    POTSPhone(POTSPhone&);
    ~POTSPhone();
private:
    Frame frameNumberVal;
    Rack rackNumberVal;
    Pair pairVal;
};

class ISDNPhone : public Telephone {
public:
    ISDNPhone();
    ISDNPhone(ISDNPhone&);
    ~ISDNPhone();
    void sendBPacket(), sendDPacket();
private:
    Channel b1, b2, d;
};

class OperatorPhone : public ISDNPhone {
public:
    OperatorPhone();
    OperatorPhone(OperatorPhone&);
    ~OperatorPhone();
    void ring();    // specjalna definicja funkcji ring
};

class PrincessPhone : public POTSPhone {
    . . . .
};

