/* Copyright (c) 1992 AT&T Bell Laboratories. */
/* C++. Styl i technika zaawansowanego programowania */
/* James O. Coplien */
/* Wszystkie prawa zastrzeone. */

void
ShapeRep::gcCommon(size_t nbytes, const size_t poolInitialized,
        const int PoolSize, Char_p &heap) {
    size_t s = nbytes? nbytes: poolInitialized;
    size_t Sizeof = Round(s);
    ShapeRep *tp = (ShapeRep *)heap;
    for (int i = 0; i < PoolSize; i++) {
        switch (nbytes) {
        case 0:   // zwyky przypadek odzyskiwania nieuytkw
            if (tp->inUse) {
                if (tp->gcmark || tp->space != FromSpace) {
                    // nie usuwa
                    tp->space = ToSpace;
                } else if (tp != tp->type()) {
                    // pami obiektu wymaga odzyskania
                    tp->ShapeRep::~ShapeRep();
                    tp->inUse = 0;
                    printf("ShapeRep::gcCommon ");
                    printf("Odzyskany obiekt klasy Triangle %c\n",
                     'A' + (((char *)tp-(char *)heap)/Sizeof));
                }
            }
            break;
        default:   // inicjacja
            tp->inUse = 0;
            break;
        }
        tp->gcmark = 0;
        tp = (ShapeRep*)(Char_p(tp) + Sizeof);
    }
}

